// Package trace ...
//
// Description : trace ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2022-10-14 23:10
package trace

const (
	// BehaviorActionTypeStart 开始某一行为
	BehaviorActionTypeStart = "start"
	// BehaviorActionTypeFinish 完成某一行为
	BehaviorActionTypeFinish = "finish"
)

// Behavior 行为信息
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 23:10 2022/10/14
type Behavior struct {
	ID              int                    `json:"id"`                // 行为ID
	StartBehaviorID int                    `json:"start_behavior_id"` // 开始行为的ID,仅对 finish 类型的行为有效
	Stack           CallStack              `json:"stack"`             // 调用堆栈信息
	Action          string                 `json:"action"`            // 行为
	Type            string                 `json:"type"`              // 行为记录类型
	Timestamp       int64                  `json:"timestamp"`         // 触发行为的时间,纳秒时间戳
	Data            map[string]interface{} `json:"data"`              // 本次行为附带的数据
}

// CallStack 调用堆栈
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 00:48 2022/10/15
type CallStack struct {
	FilePath string `json:"file_path"` // 文件路径
	LineNo   int    `json:"line_no"`   // 所在行号
}
